/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the HubspotConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &HubspotConnectorForm{}

// HubspotConnectorForm struct for HubspotConnectorForm
type HubspotConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// Source label
	Label string `json:"label"`
	// OAuth ID
	OAuthId string `json:"oAuthId"`
	// Object to be queried
	Object string `json:"object"`
	// List of selected fields
	Property []string `json:"property"`
	// Final selections of the attributes to be included in the source
	Attributes []string `json:"attributes,omitempty"`
}

// NewHubspotConnectorForm instantiates a new HubspotConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHubspotConnectorForm(connectorId string, templateId string, strategy string, label string, oAuthId string, object string, property []string) *HubspotConnectorForm {
	this := HubspotConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.Label = label
	this.OAuthId = oAuthId
	this.Object = object
	this.Property = property
	return &this
}

// NewHubspotConnectorFormWithDefaults instantiates a new HubspotConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHubspotConnectorFormWithDefaults() *HubspotConnectorForm {
	this := HubspotConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *HubspotConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *HubspotConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *HubspotConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *HubspotConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *HubspotConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *HubspotConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *HubspotConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *HubspotConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *HubspotConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *HubspotConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HubspotConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *HubspotConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *HubspotConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetLabel returns the Label field value
func (o *HubspotConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *HubspotConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *HubspotConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetOAuthId returns the OAuthId field value
func (o *HubspotConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *HubspotConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *HubspotConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetObject returns the Object field value
func (o *HubspotConnectorForm) GetObject() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Object
}

// GetObjectOk returns a tuple with the Object field value
// and a boolean to check if the value has been set.
func (o *HubspotConnectorForm) GetObjectOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Object, true
}

// SetObject sets field value
func (o *HubspotConnectorForm) SetObject(v string) {
	o.Object = v
}

// GetProperty returns the Property field value
func (o *HubspotConnectorForm) GetProperty() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Property
}

// GetPropertyOk returns a tuple with the Property field value
// and a boolean to check if the value has been set.
func (o *HubspotConnectorForm) GetPropertyOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Property, true
}

// SetProperty sets field value
func (o *HubspotConnectorForm) SetProperty(v []string) {
	o.Property = v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *HubspotConnectorForm) GetAttributes() []string {
	if o == nil || IsNil(o.Attributes) {
		var ret []string
		return ret
	}
	return o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HubspotConnectorForm) GetAttributesOk() ([]string, bool) {
	if o == nil || IsNil(o.Attributes) {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *HubspotConnectorForm) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given []string and assigns it to the Attributes field.
func (o *HubspotConnectorForm) SetAttributes(v []string) {
	o.Attributes = v
}

func (o HubspotConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o HubspotConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["label"] = o.Label
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["object"] = o.Object
	toSerialize["property"] = o.Property
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	return toSerialize, nil
}

type NullableHubspotConnectorForm struct {
	value *HubspotConnectorForm
	isSet bool
}

func (v NullableHubspotConnectorForm) Get() *HubspotConnectorForm {
	return v.value
}

func (v *NullableHubspotConnectorForm) Set(val *HubspotConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableHubspotConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableHubspotConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHubspotConnectorForm(val *HubspotConnectorForm) *NullableHubspotConnectorForm {
	return &NullableHubspotConnectorForm{value: val, isSet: true}
}

func (v NullableHubspotConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHubspotConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
